/*
** This is where all the game
** stuff is. So there.
**
*/

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <math.h>

#include "game.h"
#include "ogl.h"
#include "constants.h"

#define randx() rand() % G_WIDTH
#define randy() rand() % G_HEIGHT /*I'm feeling randy()!*/
#define randtex() (rand() % (MAX_TEXTURES-1))+1
#define randmess() rand() % num_nki

const float piover180 = 0.0174532925f;

extern int num_texture;
extern float GetTextLength( char *text );

/*
** Global variables of death
*/
int doing;      // just what the bloody hell do we think we're doing?!
int rfk_ticks;  // Used for effect timing etc.
int num_nki;    // Number of Non-kitten items in file
int num_bogus;  // Number of bogus items to show

msg_bogus nki[MAX_MESSAGES];        // Non-kitten items
screen_object bogus[MAX_MESSAGES];  // bogus items
screen_object robot;                // Mr. Roboto
screen_object kitten;               // Kitten-san
int used_mess[MAX_MESSAGES];        // Messages already allocated
int screen[G_WIDTH][G_HEIGHT];      // Game board
char keydown[256];
int show_msg;                        // Message to show
extern float zoom;

msg_bogus rfkGetNki( void )
{
    return nki[show_msg];
}

/*
** Load messages from disk
*/
bool rfkLoadMessages( void )
{
    FILE* mfile;
    int n;

    if(( mfile = fopen( "messages.txt", "r" ) ) == NULL) return false;

    num_nki = 0;
    while( (!feof( mfile )) && ( num_nki < MAX_MESSAGES ) ) {
        fgets( nki[ num_nki ].str, 120, mfile );
        if( (n = strlen( nki[ num_nki ].str )) > 0 )
        {
            if( nki[ num_nki ].str[ n-2 ] < 14 ) nki[ num_nki ].str[ n-2 ] = 0;
            if( nki[ num_nki ].str[ n-1 ] < 14 ) nki[ num_nki ].str[ n-1 ] = 0;
            nki[ num_nki ].width = -GetTextLength( nki[ num_nki ].str )/2;
            nki[ num_nki ].len = strlen( nki[ num_nki ].str );
            num_nki++;
        }
    }

    fclose( mfile );
    return num_nki != 0;
}

/*
** Start a new game
*/
void rfkStartGame( void )
{
    int i, j;

    doing = DOING_GAME;     // do the game, you!
    zoom = 1;
    rfk_ticks = 0;

    // Clear the game board
    for( i=0; i<G_WIDTH; i++ )
        for( j=0; j<G_HEIGHT; j++ )
            screen[ i ][ j ] = G_EMPTY;

    // Clear used message array
    for( i=0; i<num_nki; i++ )
        used_mess[i] = 0;

    // Initialise the robot
    robot.texture = 0;
    robot.ang = 0;
    robot.x = (float)((int)randx());
    robot.y = (float)((int)randy());
    screen[ (int)robot.x ][ (int)robot.y ] = G_ROBOT;

    // Initialise the kitten
    kitten.texture = randtex();
    do {
        kitten.x = (float)((int)randx());
        kitten.y = (float)((int)randy());
    } while( screen[ (int)kitten.x ][ (int)kitten.y ] != G_EMPTY );
    screen[ (int)kitten.x ][ (int)kitten.y ] = G_KITTEN;

    // Distribute random bogus items
    for( i=0; i<num_bogus; i++ )
    {
        bogus[ i ].texture = randtex();    //randtex();
        do {
            bogus[i].x = (float)((int)randx());
            bogus[i].y = (float)((int)randy());
        } while( screen[ (int)bogus[ i ].x ][ (int)bogus[ i ].y ] != G_EMPTY );

        screen[ (int)bogus[ i ].x ][ (int)bogus[ i ].y ] = G_BOGUS;

        do {
            bogus[ i ].message = randmess();
        } while( used_mess[ bogus[ i ].message ] == 1 );

        used_mess[ bogus[ i ].message ] = 1;
    }
}

/*
** End current game and initialise instructions
*/
void rfkEndGame( void )
{
    doing = DOING_INSTRUCTIONS;             // We're in the instructions!
    rfk_ticks = 0;
}

/*
** Initialise things when first run
*/
bool rfkInitGame( void )
{
    int i;

    if( gl_Init() == false ) return false;  // Prepare OpenGL
    if( rfkLoadMessages() == false ) return false;

    num_bogus = DEFAULT_BOGUS;

    for( i=0; i<256; i++ ) keydown[i] = 0;

    rfkEndGame();
    return true;
}


/*
** Destroy EVERYTHING! DESTROY DESTROY!
*/
void rfkShutDown( void )
{
    gl_Kill();
}

/* rfkCheckBlock */
void rfkCheckBlock( float cx, float cy )
{
    int i,bx,by,j;
    float dist,dx,dy;

    bool collide = false;

    // Within bounds?
    bx = (int)cx;
    by = (int)cy;
    if(( bx < 0 ) || ( bx >= G_WIDTH ) || ( by < 0 ) || ( by >= G_HEIGHT )) return;
    
    // Check for collision with kitten
    dx = kitten.x - cx;
    dy = kitten.y - cy;
    dist = sqrt( dx*dx + dy*dy );

    // robotfindskitten!!!
    if( fabs( dist ) <= 1.0f )
    {
        collide = true;
        doing = DOING_WIN_MESSAGE;
        rfk_ticks = 0;
        for( j=0; j<256; j++ ) keydown[ j ] = 0;
        return;
    }
    
    // Check for collisions with bogus objects
    for( i=0; i<num_bogus; i++ )
    {
        dx = bogus[ i ].x - cx;
        dy = bogus[ i ].y - cy;
        dist = sqrt( dx*dx + dy*dy );   // Distance to object
        if( fabs( dist ) <= 1.0f )
        {
          collide = true; // collided?
          doing = DOING_MESSAGE;
          show_msg = bogus[ i ].message;
          for( j=0; j<256; j++ ) keydown[ j ] = 0;
        }
    }

    if( !collide )
    {
        robot.x = cx;
        robot.y = cy;
    }
}

/*
** Process one tick.
** Do not use headlice cream on this game.
*/
void rfkGameTick( void )
{
    float checkx, checky;

    switch( doing ) {
    case DOING_INSTRUCTIONS:
        (void) rand();                // random!
        break;    
    case DOING_GAME:

        // Process stickykeys
        if( keydown[ 'O' ] == 1 ) robot.ang += 1;
        if( keydown[ 'P' ] == 1 ) robot.ang -= 1;
        if( keydown[ 'Q' ] == 1 )
        {
            checkx = robot.x - sin( robot.ang*piover180 ) * 0.15f;
            checky = robot.y - cos( robot.ang*piover180 ) * 0.15f;
            rfkCheckBlock( checkx, checky );
        }
        if( keydown[ 'A' ] == 1 )
        {
            checkx = robot.x + sin( robot.ang*piover180 ) * 0.15f;
            checky = robot.y + cos( robot.ang*piover180 ) * 0.15f;
            rfkCheckBlock( checkx, checky );
        }
        break;
    }

    // Done a tick!
    rfk_ticks++;
}

/*
** Process keys
** Produces canned piano keys
*/
void rfkProcessKey( int code, bool isdown )
{
    switch( doing ) {

    case DOING_WIN_MESSAGE:
        if(( isdown ) && ( zoom >= 12.0f ))   // only check after zoom sequence
        {
            doing = DOING_INSTRUCTIONS;
            rfk_ticks = 0;
        }
        break;
    case DOING_MESSAGE:
        if( isdown ) doing = DOING_GAME;
        break;
    case DOING_INSTRUCTIONS:
        if( isdown ) rfkStartGame();
        break;

    case DOING_GAME:

        if( isdown )
        {
            switch( code ) {
            case 27:
                rfkEndGame();
                break;
            default:
                keydown[ code ] = 1;
                break;
            }
        }
        else
        {
            keydown[ code ] = 0;
        }
        break;
    }
}

